<?php

/*

   This program displays a given angular argument in various contexts.
   The angle can be interpreted as a standard DMS angle or an HMS hour angle.

   Author : Jay Tanner - PHPScienceLabs.com
   License: Public Domain

*/


   $out = "";

   $cYear = gmdate("Y");

   $_PROGRAM_VERSION_ = 'v4.3';

// ---------------------------------------
// Read input angle value.  This can be in
// decimal degrees, decimal hours, DMS or
// HMS format.

   $AngVal = @$_POST['AngVal'];

   $AngVal = Filter_Out_Ang_Symbols($AngVal);

   $out = $AngDeg = $AngDMS = $AngHrs = $AngHMS =
   $degrees = $hours = $out = '';

// COMPUTE EQUIVALENTS ACCORDING TO WHICH BUTTON WAS CLICKED.



// DO THIS IF STANDARD ANGLE BUTTON WAS CLICKED.
   if (isset($_POST['s_angle_button']))
  {
// Convert DMS input to decimal degrees format and
// compute equivalents.
   $AngDeg = DMS_to_Deg($AngVal); $AngVal = $AngDeg;
   $ModDeg = Deg_Mod_360($AngDeg);

   $AngDMS = Deg_to_DMS($AngDeg, 6, '', 'd');
   $ModDMS = Deg_to_DMS($ModDeg, 6, '', 'd');

   $AngHrs = $AngDeg / 15;
   $ModAngHrs = bcDiv(Deg_Mod_360($AngDeg), '15', 14) ;
   $AngHMS = Hours_to_HMS($AngHrs, 6, '', 'h');
   $ModAngHMS = Hours_to_HMS($ModAngHrs, 6, '', 'h');

// Modulated radians value.
   $AngRad = deg2rad($ModDeg);

// COMPUTE CIRCULAR TRIG FUNCTIONS FOR DEGREE ANGLE VALUE.
   $SinAng = sin($AngRad);
   $CosAng = cos($AngRad);
   $TanAng = tan($AngRad);

// FORMAT VALUES FOR OUTPUT.
   $AngVal = $AngDeg = sprintf("%1.14f", $AngDeg);
   $AngRad = sprintf("%1.14f", $AngRad);
   $ModDeg = sprintf("%1.14f", $ModDeg);
   $AngHrs = sprintf("%1.14f", $AngHrs);

   $SinAng = sprintf("%+1.14f", $SinAng);
   $CosAng = sprintf("%+1.14f", $CosAng);
   $TanAng = sprintf("%+1.14f", $TanAng);

// filters for ±Infinity
   if ($AngDeg == -180 or $AngDeg ==  90){$TanAng = '+Infinity';}
   if ($AngDeg ==  180 or $AngDeg == -90){$TanAng = '-Infinity';}

   $out .=
" STANDARD DEGREE ANGLE CONTEXT

 $AngDeg&deg;\t\t= $AngDMS

 MODULATED to RANGE 0&deg; to 360&deg;
 $ModDeg&deg;\t\t= $ModDMS

 MODULATED CIRCULAR EQUIVALENTS
 Hours   = $ModAngHrs \t= $ModAngHMS
 Radians = $AngRad

 CIRCULAR TRIG FUNCTIONS
 sin = $SinAng
 cos = $CosAng
 tan = $TanAng";
 }


// DO THIS IF HOUR ANGLE BUTTON WAS CLICKED.
   if (isset($_POST['h_angle_button']))
{
// Convert HMS input to decimal hours format and
// compute equivalents.
   $AngHrs = HMS_to_Hours($AngVal); $AngVal = $AngHrs;
   $AngHMS = Hours_to_HMS($AngHrs, 6, '+', 'h');

   $AngDeg = 15 * $AngHrs;
   $AngDMS = Deg_to_DMS($AngDeg, 6, '+', 'd');

   $AngRad = deg2rad($AngDeg);

// COMPUTE CIRCULAR TRIG FUNCTIONS FOR DEGREE ANGLE VALUE.
   $SinAng = sin($AngRad);
   $CosAng = cos($AngRad);
   $TanAng = tan($AngRad);

// FORMAT VALUES FOR OUTPUT.
   $AngHrs = sprintf("%+1.14f", $AngHrs);
   $AngDeg = sprintf("%+1.14f", $AngDeg);
   $AngRad = sprintf("%+1.14f", $AngRad);
   $AngVal = sprintf("%+1.14f", $AngHrs);

   $SinAng = sprintf("%+1.14f", $SinAng);
   $CosAng = sprintf("%+1.14f", $CosAng);
   $TanAng = sprintf("%+1.14f", $TanAng);

// filters for ±Infinity
   if ($AngDeg == -180 or $AngDeg ==  90){$TanAng = '+Infinity';}
   if ($AngDeg ==  180 or $AngDeg == -90){$TanAng = '-Infinity';}

   $out .=
" HOUR ANGLE CONTEXT

 $AngHrs h\t\t=   $AngHMS

 EQUIVALENTS
 Degrees = $AngDeg \t=  $AngDMS
 Radians = $AngRad

 CIRCULAR TRIG FUNCTIONS
 sin = $SinAng
 cos = $CosAng
 tan = $TanAng";
}








print <<< _HTML

<!DOCTYPE HTML>

<HTML lang='en'>

<head>

<title>Degree Angle / Hour Angle Equivalents</title>
<meta name='viewport' content='width=device-width, initial-scale=1'>
<meta http-equiv='content-type' content='text/html; charset=UTF-8'>
<meta name='description' content='Angular Equivalents For Standard Degree Angles or Hour Angles'>
<meta name='keywords' content='angular conversion,angular equivalents,degree angle,hour angle'>
<meta name='author' content='Jay Tanner - PHPScienceLabs.com'>
<meta http-equiv='pragma'  content='no-cache'>
<meta http-equiv='expires' content='-1'>
<meta name='robots'    content='index,follow'>
<meta name='googlebot' content='index,follow'>
<link rel="canonical" href="https://www.phpsciencelabs.com/degree-and-hour-angular-equivalents/">

<style type='text/css'>
BODY {font-family:Verdana;   font-size:100%; line-height:125%;}
DIV  {font-family:Verdana;   font-size:100%; line-height:125%;}
PRE  {font-family:monospace; font-size:125%; font-weight:bold; text-align:left;}
CODE {font-family:monospace; font-size:125%; font-weight:bold;}
HR   {background:black; height:2px; border:0px;}

TD   {background:white; color:black; font-family:Verdana; text-align:left; padding:4px;}

INPUT[type='text']::-ms-clear {width:0; height:0;}
INPUT[type='text']{color:black; background:white; font-family:monospace; font-size:175%; font-weight:bold; text-align:center; box-shadow:2px 2px 3px #999999; border:2px solid black; border-radius:4px;}
INPUT[type='text']:focus {color:black; background:white; font-family:monospace; font-size:175%; font-weight:bold; text-align:center; box-shadow:2px 2px 3px #666666; border:2px solid blue;  border-radius:4px;}

IMG {box-shadow:2px 2px 2px #999999; border:1px solid #808080; border-radius:8px;}

INPUT[type='submit']{font-weight:bold; font-size:100%; border-radius:4px; border:1px solid black; padding:3px;}
INPUT[type='submit']:hover {box-shadow:2px 2px 2px #444444; background:cyan; font-size:100%; font-weight:bold; border-radius:4px; padding:3px;}

TEXTAREA  {background:white; color:black; font-size:150%; font-family:monospace; font-weight:bold; box-shadow:4px 4px 3px #999999; border-radius: 8px; border:2px solid blue; padding:6px; word-wrap: break-word;}

A:link    {background:transparent; color:blue;  font-size:90%;  font-family:Verdana; font-weight:bold; text-decoration:none; line-height:175%; padding:2px; border:1px solid transparent;}
A:visited {background:transparent; color:blue;  font-size:90%;}
A:hover   {background:transparent; color:blue;  font-size:90%;}
A:active  {background:transparent; color:black; font-size:90%;}

::selection      {background:yellow; color:black;}  /* For IE9+ and Safari     */
::-moz-selection {background:yellow; color:black;}  /* For FireFox and Mozilla */
</style>

<meta name="robots"    content="index,nofollow">
<meta name="googlebot" content="index,nofollow">

</head>

<body style='background:black;'>

<table width="600" align="bottom" cellpadding='6'>

<tr><td style="color:white; background-color:#000066; font-family:Verdana; font-size:125%; font-weight:normal; text-align:center; border:2px solid white; border-radius:8px 8px 0px 0px;">Standard Degree Angle / Hour Angle Equivalents<br><br><span style='font-size:80%;'>PHP Program by Jay Tanner</span></td></tr>

<tr><td style="background:white; text-align:center; line-height:150%">
<br>
<b>Enter Standard Degree Angle or Hour Angle Argument Elements</b><br>(Deg.ddd &nbsp;or&nbsp; Deg&nbsp;mm&nbsp;ss.sss &nbsp;&nbsp;or&nbsp;&nbsp; Hours.hhh &nbsp;or&nbsp; hh&nbsp;mm&nbsp;ss.sss)
<br><br>
<form name="form1" method="post" action="">
<input type="text" name="AngVal" value="$AngVal" size="36" maxlength="34">

<br><br>
Context:<br>
<input type="submit" name="s_angle_button" value="Degree Angle">
<input type="submit" name="h_angle_button" value="Hour Angle">

</label>
</form>

<br>
This program will display two interpretation contexts of a standard degree angle<BR>or an hour angle and the values of the related circular trigonometric functions.
<br><br>
Double-Click Within Text Area to Select ALL Text
<textarea style='font-family:monospace; font-size:150%; font-weight:bold; text-align:left;' cols='60' rows='17' readonly='readonly'OnDblClick='this.select();' OnMouseUp='return true;'>
$out
</textarea>

<br>

<div style='color:gray; font-size:75%; text-align:center;'>Jay Tanner - $cYear</div>

</td></tr>
</table>

</body>

</HTML>


_HTML;





// ================================================
// This BC math function adds a sequence of squared
// numbers to the specified decimals of precision.

   function bcAdd_Seq_Sqr ($SeqStrArg, $NumDecimals)

{

// ----------------------------------------------
// Remove redundant white space from data vector.
   $SeqStr = preg_replace('/\s+/', ' ', trim($SeqStrArg));

// -----------------------
// Get number of decimals.
   $d = trim($NumDecimals);

// -----------------------------------------------
// Separate items to be summed into working array.
   $item = split ("[ ]", trim($SeqStr));

// -------------------------
// Count items to be summed.
   $ItemCount = count($item);

// --------------------------------
// Handle case of empty items list.
   if ($ItemCount == 0) {return "0";}

// -----------------------------------
// Handle case of single item in list.
   if ($ItemCount == 1) {return $item[0];}

// -------------------
// Sum the items list.
   $sum = "0";

   for ($i=0;  $i < $ItemCount;   $i++)
       {
        $sq = bcMul($item[$i], $item[$i], $d+16);
        $sum = bcAdd($sum, $sq, $d+16);
       }

   return bcAdd("0", $sum, $d);

} // End of  bcAdd_Seq_Sqr()




/*

   This function rounds off a given decimal
   value to a given number of decimals.



   The rounding is absolute.

   The argument ($xStrArg) should be a numeric
   string, like "1.23456789"

*/

   function bcRound ($xStrArg, $NumDecimalsArg)

{
   $SignStr = (substr($xStrArg,0,1) == "-" )? "-" : "";

   $x = str_replace("-", "", $xStrArg);

   $decimals = $NumDecimalsArg;

   $Zeros5 = "";

   for ($i=0;   $i < $decimals;   $i++)
       {$Zeros5 .= "0";} $Zeros5 .= "5";

   $x = bcAdd($x, "0.$Zeros5", $decimals);

   return "$SignStr$x";
}



/*

=======================================
This function is designed to modulate a
negative or positive angle expressed in
degrees to fall within the standard
range from 0 to +360 degrees.

*/

   function Deg_Mod_360 ($DegArg)
{

// ----------------------
// Read degrees argument.
   $x = trim($DegArg);

// --------------------
// Set internal working
// decimals limit.
   $d = 24;

// --------------------------------------
// Remember numerical � sign of argument.
   $sign = ($x < 0) ? -1 : 1;

// -------------------------------------
// Work with absolute value of argument.
   $x = bcMul($sign, $x, $d);

// ------------------------
// Compute (Angle MOD 360).
   $w = bcSub($x, bcMul(bcDiv($x, "360"), "360"), $d);

// ------------------------
// Recall numerical � sign.
   if ($sign < 0) {$w = bcSub("360", $w, $d);}

// ----------------------------
// Done.  Return result rounded
// to 16 decimals.

   return bcAdd($w, "0.00000000000000005", 16);


} // End of  Deg_Mod_360()





/*
   Convert DMS string to decimal degrees.

   Example: Given DMS string = "9 12 50.306"
            Returned = 9.2139738888888889

*/

   function DMS_to_Deg ($DMSstr)
{

// ----------------------------------------------------------
// Read angle/time string argument and force to lower case in
// the event any (deg d h m s : � ' ") symbols are used.

   $dms = strtolower(trim($DMSstr));

// ------------------------------------------------------
// Convert any (deg d m s � ' ") symbols into spaces.

   $dms = str_replace('deg', ' ', $dms);
   $dms = str_replace('d',   ' ', $dms);
   $dms = str_replace('m',   ' ', $dms);
   $dms = str_replace('s',   ' ', $dms);
   $dms = str_replace('�',   ' ', $dms);
   $dms = str_replace("'",   ' ', $dms);
   $dms = str_replace('"',   ' ', $dms);
   $dms = str_replace("&deg;",   ' ', $dms);
// ----------------------------------------------------
// Normalize the spacing and then split and extract the
// individual angle/time string elements (dh or hh, mm,ss).

   $dms = preg_replace("/\s+/", " ", trim($dms));
   $wdms = preg_split("[ ]", $dms);
   $wdmsCount = count($wdms);
   $dd = ($wdmsCount >= 1)? bcadd($wdms[0],"0", 20) : "0";
   $mm = ($wdmsCount >= 2)? bcadd($wdms[1],"0", 20) : "0";
   $ss = ($wdmsCount >= 3)? bcadd($wdms[2],"0", 20) : "0";

// ------------------------------------------------
// Remember and then remove any numerical (�) sign.

   $NumSign = (substr($DMSstr,0,1) == '-')? '-' : '';
   $dd = str_replace('-', '', $dd);
   $dd = str_replace('+', '', $dd);

// -------------------------------------------------------------
// If original angle argument began with a + sign, then preserve
// it so that all returned positive results will have a + sign.
// Otherwise, positive results will NOT have a + sign.

   if (substr($DMSstr,0,1) == '+') {$NumSign = '+';}

// ----------------------------------------------
// Compute decimal degrees/hours value equivalent
// to the given dhms argument elements.

   $w2 = bcadd(bcadd(bcmul($dd,"3600",20),bcmul($mm,"60",20),20),$ss,20);

// -----------------------------------------------------------
// If result equates to zero, then suppress any numerical sign.

   if (bccomp($w2, "0", 20) == 0) {$NumSign = '';}

// ---------------------------------------------------------
// Round off result to 16 decimals, recalling original sign.

   return $NumSign . bcadd(bcdiv($w2,"3600",20), "0.00000000000000005",16);

} // End of  DMS_to_Deg (...)



/*
   ========================================================================
   Convert decimal degrees to degrees, minutes, seconds of arc.
   The angular elements are returned in a space-delimited string.

   Optional symbols are attached to the angle elements. The seconds can
   optionally be rounded to up to 3 decimals with 0=Default.

   Symbols mode = TRUE|FALSE or d|D
   TRUE|d|D means to apply DMS symbols to returned string.
   FALSE means no DMS symbols are applied to returned string.

   ========================================================================
*/

   function Deg_to_DMS ($AngDeg, $ssDecimals=0, $PosSignSymbol='', $SymbolsMode='d')
{

// Init
   $_d_ = $_m_ = $_s_ = '';

// ------------------------------------------------------
// Compute signed angular elements from decimal argument.
// This value is taken as decimal degrees.
   $sign = ($AngDeg < 0)? '-' : '';

   if (($PosSignSymbol === TRUE or $PosSignSymbol == '+') and $sign == '') {$sign = '+';}

   $degrees = abs($AngDeg);
   $dd      = floor($degrees);
   $minutes = 60*($degrees - $dd);
   $mm      = floor($minutes);
   $seconds = 60*($minutes - $mm);
   $ss      = sprintf("%1.$ssDecimals"."f", $seconds);

// ----------------------------------
// Check for that blasted 60s glitch.
   if ($ss == 60) {$ss = 0; $mm++;}
   if ($mm == 60) {$mm = 0; $dd++;}

// ----------------------------
// Format the angular elements.
   $dd = sprintf("%03d",  $dd);
   $mm = sprintf("%02d",  $mm);
   $ss = sprintf("%1.$ssDecimals"."f", $ss);

   if ($ss < 10) {$ss = "0$ss";}
// Attach optional DMS symbols.
// Default = TRUE. Can also use 'd' for DMS symbols flag.
   if ($SymbolsMode === TRUE or substr(strtolower($SymbolsMode),0,1) == 'd')
      {
       $_d_ = "&deg;";
       $_m_ = "'";
       $_s_ = '"';
      }

// Done.
   return "$sign$dd$_d_ $mm$_m_ $ss$_s_";

} // End of  Deg_to_DMS (...)





















/*
   Converts decimal hours into an hours, minutes
   and seconds string.

   For example, the arguments (10.123456789, 3)
   hours would return the string "10h 07m 24.444s"

   $PosSignSymbol = + if positive value or empty = No sign symbol

   $SymbolsMode = h or :
                  FALSE = No symbols
                  : = Use colons (:) instead of h,m,s symbols
                  h = Use h,m,s symbols instead of colons (= Default).

*/
   function Hours_to_HMS ($hours, $ssDecimals=0, $PosSignSymbol='', $SymbolsMode='h')
{

// ---------------------------
// Initialize symbol carriers.
   $_h_ = $_m_ = $_s_ = '';

   if (trim($PosSignSymbol) == '')  {$PosSignSymbol = FALSE;}

// --------------------------------------------------------------
// Remember original numerical sign and work with absolute value.
   $sign = ($hours < 0)? '-' : '';    $hours = abs($hours);

// -------------------------------------------------------
// Remember numerical sign to be restored on exit, if any.
//   if (($PosSignFlag === TRUE or $PosSignFlag == '+') and $sign == '')
//      {$sign = '+';}

   if (($PosSignSymbol === TRUE or $PosSignSymbol == '+') and $sign == '') {$sign = '+';}

// ---------------------------------------------------
// Compute time elements from absolute hours argument.
   $hh = floor($hours);
   $minutes = 60*($hours - $hh);    $mm = floor($minutes);
   $seconds = 60*($minutes - $mm);  $ss = sprintf("%1.$ssDecimals"."f",  $seconds);

// -------------------------
// Format the time elements.
   $hh = sprintf("%02d",  $hh);
   $mm = sprintf("%02d",  $mm);
   $ss = sprintf("%1.$ssDecimals"."f", $ss);

// ----------------------------------
// Patch for that blasted 60s glitch.
   if ($ss == 60) {$ss = 0; $mm++;}
   if ($mm == 60) {$mm = 0; $hh++;}

   $hh = sprintf("%02d",  $hh);
   $mm = sprintf("%02d",  $mm);

   $ss = sprintf("%1.$ssDecimals" . "f", $ss);
   if ($ss < 10) {$ss = "0$ss";}

// -----------------------------------------------
// Attach optional (h m s :) symbols as indicated.
// Default = 'h'
   if ($SymbolsMode == 0 or $SymbolsMode == '')
      {$_h_  =  $_m_  =  $_s_  = ' ';}

   if ($SymbolsMode == 1 or $SymbolsMode == ':')
      {$_h_  =  ':';  $_m_  =  ':';  $_s_  = '';}

   if ($SymbolsMode == 2 or strtolower($SymbolsMode) == 'h')
      {$_h_  =  'h ';  $_m_  =  'm ';  $_s_  =  's';}

// Done.
   return "$sign$hh$_h_$mm$_m_$ss$_s_";

} // End of  Hours_to_HMS(...)


   function HMS_to_Hours ($hhmmss)
{

// -----------------------------------------------------------
// Read hour angle string argument and force to lower case in
// the event any (h m s :) symbols are used.

   $hms = strtolower(trim($hhmmss));

// ------------------------------------------------------
// Convert any (h m s :) symbols into spaces.

   $hms = str_replace('h', ' ', $hms);
   $hms = str_replace('m', ' ', $hms);
   $hms = str_replace('s', ' ', $hms);
   $hms = str_replace(':', ' ', $hms);


// ----------------------------------------------------
// Normalize the spacing and then split and extract the
// individual time string elements (hh, mm,ss).

   $hms = preg_replace("/\s+/", " ", trim($hms));
   $whms = preg_split("[ ]", $hms);
   $whmsCount = count($whms);
   $hh = ($whmsCount >= 1)? bcadd($whms[0],"0", 20) : "0";
   $mm = ($whmsCount >= 2)? bcadd($whms[1],"0", 20) : "0";
   $ss = ($whmsCount >= 3)? bcadd($whms[2],"0", 20) : "0";

// ------------------------------------------------
// Remember and then remove any numerical (�) sign.

   $NumSign = (substr($hhmmss,0,1) == '-')? '-' : '';
   $hh = str_replace('-', '', $hh);
   $hh = str_replace('+', '', $hh);

// -------------------------------------------------------------
// If original angle argument began with a + sign, then preserve
// it so that all returned positive results will have a + sign.
// Otherwise, positive results will NOT have a + sign.

   if (substr($hhmmss,0,1) == '+') {$NumSign = '+';}

// --------------------------------------
// Compute decimal hours value equivalent
// to the combined hh,mm,ss values.

   $w2 = bcadd(bcadd(bcmul($hh,'3600',20),bcmul($mm,'60',20),20),$ss,20);

// ------------------------------------------------------------
// If result equates to zero, then suppress any numerical sign.

   if (bccomp($w2, '0', 20) == 0) {$NumSign = '';}

// ---------------------------------------------------------
// Round off result to 16 decimals, recalling original sign.

   $w =  bcadd(bcdiv($w2,3600, 20), '0.00000000000000005', 16);

// Trim off any redundant zeros/decimal point.
   return $NumSign . rtrim(rtrim($w, '0'), '.');

} // End of  HMS_to_Hours(...)




   function filter_out_ang_symbols($AngString)
{
   $AngStr = trim($AngString);

   $AngStr = str_replace("°"," ", $AngStr);
   $AngStr = str_replace("'"," ", $AngStr);
   $AngStr = str_replace('"'," ", $AngStr);
   $AngStr = str_replace("&deg;"," ", $AngStr);
   $AngStr = str_replace("&#39;"," ", $AngStr);
   $AngStr = str_replace("&#34;"," ", $AngStr);
   $AngStr = str_replace("h"," ", $AngStr);
   $AngStr = str_replace("m"," ", $AngStr);
   $AngStr = str_replace("s"," ", $AngStr);

   return $AngStr;
}



?>


